
#define MAX_LINE_LENGTH 255



  typedef unsigned char	 BYTE;
  typedef unsigned short SHORT;
  typedef unsigned long DWORD;
  typedef unsigned long	Uint32;


    void Sleep(unsigned int  useconds )
    {
    // 1 milliseconds = 1000 microsecond.
    // Windows Sleep uses miliseconds
    // linux usleep uses microsecond
    // and since the default
    // usage of the code was under windows
    // so the argument is   coming in millisecond.
        usleep( useconds * 1000 );
    }

    Uint32 GetTickCount()
    {
        tms tm;
        return times(&tm)*10;
    }
    Uint32 GetCurrentDirectory(Uint32 BufferLength,char * Buffer)
    {
        getcwd(Buffer,BufferLength);
        return 0;
    }

    Uint32 closesocket (Uint32 WhoIsLookupSocket)
    {
            return close(WhoIsLookupSocket);
    }

  /*  float min(float a, float b)
    {
        return (a < b ? a : b);
    }  */

long GetPrivateProfileString(char* lpAppName,char* lpKeyName,char* lpDefault,char* lpReturnedString,long nSize,char* lpFileName)
{
	FILE* fp;
	int rightApp=0;
	char line[1024];
	char *c1,*c2;
	*lpReturnedString=0;
	
	fp=fopen(lpFileName,"r");
	if (!fp) return 0;
	
	while (fgets(line,1024,fp)){
		
		// truncate line after comment char (;)
		if (*line==';') continue;
		for (c1=line;c1<(line+strlen(line));c1++) if (*(c1)==';') *(c1)=0;
		
		// check for apps
		if ((*line=='[')&&(c2=strchr(line,']'))){
			c1=line+1;
			*c2=0;
			if (!strcasecmp(c1,lpAppName)) rightApp=1;
			else rightApp=0;
			continue;
		}
		
		// check for key
		if (rightApp==1){
			c1=line;
			if (c2=strchr(c1,'=')){
				*c2=0;
				if (!strcasecmp(c1,lpKeyName)){
					c2++;
					if (c2!=0){
						// exclude blanks and CR/LF at value end
						c1=c2+strlen(c2)-1;
						while ((*c1==' ')||(*c1=='\t')||(*c1=='\n')||(*c1=='\r')) c1--;
						*(c1+1)=0;
						// copy value and return
						snprintf(lpReturnedString,nSize,c2);
						break;
					}
				}
			}
		}
	}
	fclose(fp);
	//printf(lpReturnedString);
	return strlen(lpReturnedString);
}

unsigned int GetPrivateProfileInt(char* lpAppName,char* lpKeyName,int nDefault,char* lpFileName)
{
	char val[1024];
	if (GetPrivateProfileString(lpAppName,lpKeyName,"",val,1024,lpFileName)==0) return nDefault;
	else return atoi(val);
}

/*****************************************************************
* Function:     read_line()
* Arguments:    <FILE *> fp - a pointer to the file to be read from
*               <char *> bp - a pointer to the copy buffer
* Returns:      TRUE if successful FALSE otherwise
******************************************************************/
int read_line(FILE *fp, char *bp)
{   char c = '\0';
    int i = 0;
    /* Read one line from the source file */
    while( (c = getc(fp)) != '\n' )
    {   if( c == EOF )         /* return FALSE on unexpected EOF */
            return(0);
        bp[i++] = c;
    }
    bp[i] = '\0';
    return(1);
}


/***** Routine for writing private profile strings --- by Joseph J. Graf *****/


/***************************************************************************
 * Function:    write_private_profile_string()
 * Arguments:   <char *> section - the name of the section to search for
 *              <char *> entry - the name of the entry to find the value of
 *              <char *> buffer - pointer to the buffer that holds the string
 *              <char *> file_name - the name of the .ini file to read from
 * Returns:     TRUE if successful, otherwise FALSE
 ***************************************************************************/
int WritePrivateProfileString(char *section,
    char *entry, char *buffer, char *file_name)

{   
    //TODO: NOT IMPLEMENTED
    return(1);

}


/*****************************************************************************
kbhit() and getch() for Linux/UNIX
Chris Giese <geezer@execpc.com>	http://my.execpc.com/~geezer
Release date: ?
This code is public domain (no copyright).
You can do whatever you want with it.
*****************************************************************************/
#ifdef WIN32
#include <conio.h> /* kbhit(), getch() */

#else
#include <sys/time.h> /* struct timeval, select() */
/* ICANON, ECHO, TCSANOW, struct termios */
#include <termios.h> /* tcgetattr(), tcsetattr() */
#include <stdlib.h> /* atexit(), exit() */
#include <unistd.h> /* read() */
#include <stdio.h> /* printf() */

static struct termios g_old_kbd_mode;
/*****************************************************************************
*****************************************************************************/
static void cooked(void)
{
	tcsetattr(0, TCSANOW, &g_old_kbd_mode);
}
/*****************************************************************************
*****************************************************************************/
static void raw(void)
{
	static char init;
/**/
	struct termios new_kbd_mode;

	if(init)
		return;
/* put keyboard (stdin, actually) in raw, unbuffered mode */
	tcgetattr(0, &g_old_kbd_mode);
	memcpy(&new_kbd_mode, &g_old_kbd_mode, sizeof(struct termios));
	new_kbd_mode.c_lflag &= ~(ICANON | ECHO);
	new_kbd_mode.c_cc[VTIME] = 0;
	new_kbd_mode.c_cc[VMIN] = 1;
	tcsetattr(0, TCSANOW, &new_kbd_mode);
/* when we exit, go back to normal, "cooked" mode */
	atexit(cooked);

	init = 1;
}
/*****************************************************************************
*****************************************************************************/
static int kbhit(void)
{
	struct timeval timeout;
	fd_set read_handles;
	int status;

	raw();
/* check stdin (fd 0) for activity */
	FD_ZERO(&read_handles);
	FD_SET(0, &read_handles);
	timeout.tv_sec = timeout.tv_usec = 0;
	status = select(0 + 1, &read_handles, NULL, NULL, &timeout);
	if(status < 0)
	{
		printf("select() failed in kbhit()\n");
		exit(1);
	}
	return status;
}
/*****************************************************************************
*****************************************************************************/
static int getch(void)
{
	unsigned char temp;

	raw();
/* stdin = fd 0 */
	if(read(0, &temp, 1) != 1)
		return 0;
	return temp;
}
#endif
